mob/verb/simple_window()
	new /sd_window("This is a simple window.", src)

mob/verb/timed_window()
	new /sd_window("This window will automatically close in 45 seconds.", src, 450)

mob/verb/bottomright_window()
	new /sd_window("This window opens in the bottom right of the screen.", src,,5000,5000)

mob/verb/topcenter_window()
	new /sd_window("This window opens in the top center of the screen.", src,,-1,0)

mob
	var/sd_window/my_window
	verb
		new_persistent()
			set desc = "Create a new persistent sd_window."
			my_window = new("I made a fresh window", src)

		my_window_content(T as text)
			set desc = "(new content) Enter new content for your sd_window."
			if(!my_window)	// oops! better make one then
				my_window = new()
			my_window.content = T
			my_window.Display(src)

mob
	verb
		display_my_window()
			set desc = "Re-display your sd_window."
			if(!my_window)	// oops! better make one then
				my_window = new()
			my_window.Display(src)

		delete_my_window()
			set desc = "Delete the persistent sd_window."
			del(my_window)

		close_my_window()
			set desc = "Close the persistent sd_window without deleting it."
			if(!my_window) return
			my_window.Close(src, 0, 0)

mob
	verb
		toggle_my_window_sunken()
			set desc = "Toggle the SDW_SUNKEN flag for your persistent window."
			if(!my_window)	// oops! better make one then
				my_window = new()
			my_window.Close(src, 0, 0)
			my_window.flags ^= SDW_SUNKEN
			my_window.Display(src)

mob/verb/hooked_window()
	set desc = "Open a window that tells you when its program hooks are called."
	new/sd_window/hooked("I report dutifully when closed.", src)

sd_window/hooked
	// our
	Close(target)
		world << "[target] closed me!"
	NoViewers()
		world << "No one is looking at me."
		..()	// this calls the default NoViewers()

mob/verb/resource_window()
	set desc = "Open a window with external resources."

	var/sd_window/S = new("Don't look! I'm naked!  <img src=nudie.png width=96 height=96>")
	S.AddResource('naked.dmi', "nudie.png")
	S.Display(src)

mob/verb/input_window()
	set desc = "Open an input window that tells you what your input is."
	var/sd_window/input_window/I = new()	// no content now, so we can \ref this sd_window for content
	I.content = {"<head><title>Input your name</title><script>
		function BYOND(X) {
			var wndw = window;
			if(top==self) wndw = dialogArguments;
			wndw.document.location.href = 'BYOND://?src=\ref[I]&'+X;
		}
		</script>
		</head><body>
		<input ID=Name value="[usr.name]" size=30>
		<input type=BUTTON onClick="BYOND('name='+Name.value);" value="Submit">
		<body>"}
	I.Display(src)

sd_window/input_window
	// reports everything sent to Topic
	Topic(href, hlist[])
		if("name" in hlist)
			world << "[usr] entered '[hlist["name"]]'."
		..()	// so that the "CLOSED" message can go through
